% Single barrier "Down" options using a binomial tree.
% Interpolation method of Derman, Kani, Ergener, and Bardhan
% "Enhanced Numerical Methods for Options with Barriers"
% Goldman Sachs Quantitative Strategies Research Notes.
% With barrier adjustment for continuous or discrete monitoring.

clc; clear;

S = 100;          % Spot price.
K = 100;         % Strike price.
H =  80;        % Barrier level.
T = 1 ;           % Maturity.
r = 0.05;         % Risk free rate
q = 0;            % Dividend yield
v = 0.3 ;         % Volatility.
n = 200;          % Number of steps.
PutCall = 'P';    % 'C'all or 'P'ut
EuroAmer = 'A';   % 'E'uropean or 'A'merican
BarType = 'DO';   % 'UO', 'UI'
M1 = 0;           % Barrier monitor for # observations
M2 = 'M';         % Barrier monitor for frequency 'C'ontinuous 'H'ourly, 'D'aily, 'W'eekly, 'M'onthly.

% Returns the price of a "Up" barrier option.
DownBarrierOption = DermanBarrierDown(S, K, H, T, r, q, v, n, PutCall, EuroAmer, BarType, M1, M2)

% Returns the barrier modified for monitoring frequency.
ModifiedBarrier = NewBarrier(S,H,T,v,M1,M2)
